var cache = {}, subcats, subcat0, addsubcat, valid = false;
function noticeFormInit(mode){
    if (mode == undefined || mode == 'basic'){
        subcats = $('#noticeform_subcats');
        subcat0 = $(subcats.children()[0]);
        initDropDown($('#maincat'), function(root, catid){
            // remove subcats
            var cats = subcats.children();
            for (var i=1; i<cats.length; ++i){
                cats[i].remove();
            }
            addsubcat.hide();
            // reset subcat0
            resetSubCat(subcat0);
            // show/hide extra sections if needed
            extraFields(catid);
            // show/hide subcats if needed
            updateSubCats(catid, true);
        });
        addsubcat = $('#noticeform_addsubcat').on('click', function(){
            // check number of subcats
            var i = subcats.children().length + 1;
            if (i > 3){
                alert('Możesz dodać tylko 3 podkategorie!');
                return;
            }

            // add next subcat section
            makeSubCat(i);
            // hide add button
            addsubcat.hide();
        }).parent();
        if (data != undefined && data.subcats != undefined){
            initDropDown(subcat0, loadProfiles);
            // add subcats
            for (var a=0,i=0; i<3; ++i){
                if (data.subcats[i] > 0) {
                    var subcat = (a++ > 0) ? makeSubCat(a) : subcat0;
                    $('[itemid="'+data.subcats[i]+'"]', subcat).click();
                }
            }
            updateSubCats(data.maincat, false);
        }
    }
    if (mode == undefined || mode == 'taddr'){
        $('#phone1').on('keydown', intField).on('paste', intField);
        $('#postcode1, #postcode2').on('keydown', intField).on('paste', intField);
        $("#city").autocomplete({
            minLength: 2,
            source: function( request, response ) {
                var term = request.term;
                if (term in cache) {
                    response(cache[term]);
                    return;
                }
                $.getJSON("/webfront/notice/searchlocal", request, function(data, status, xhr){
                    cache[term] = data;
                    response(data);
                });
            },
            select: function(event, ui) {
                formNoError(event, $('#city').val(ui.item.label));
                $('#city_id' ).val(ui.item.id);
                $('#region').val(ui.item.wojname);
                $('#region_id').val(ui.item.woid);
                return false;
            }
        });
        initDropDown($('#area'));
    }
    if (mode == undefined || mode == 'other'){
        $('.photo img').on('click', imgClick).each(function(i,e){
            if ($(e).attr('src').length > 0)
                return adjustPhoto(e, e);
            else
                return removePhoto(e);
        });
        $('.reference img').on('click', imgClick).each(function(i,e){
            var ctx = $(e).closest('.reference');
            if ($('input[type=hidden]', ctx).length > 0)
                return adjustReference(ctx);
            else
                return removeReference(e);
        });
    }

    // close dropdowns
    $('body').click(function(e) {
        if (!$(e.target).parent().hasClass('dropdown'))
            $('.dropdown_list').hide();
    });
}
function initDropDown(root, fn){
    var fn = fn || function(){};
    var list = $('.dropdown_list', root).mouseleave(function() {
        $(this).hide();
    });
    $('.current', root).click(function(){
        $('.dropdown_list').hide();
        $(list).show();
    });
    dropDownHeight(list).on('click', function(e){
        formNoError(e, $(this).parent().parent());
        $('.dropdown_list').hide();
        var id = $(this).attr('itemid');
        if (id) {
            fn(root, id);
            var txt = $(this).text();
            $('input', root).val(id);
            $('.current', root).text(txt); 
        }
    })
}
function dropDownHeight(list){
    var items = list.first().children().filter(function(i, elem){
        return $(elem).css('display') != 'none';
    });
    list.height(Math.min(8, items.length) * 47);
    return items;
}
function makeSubCat(i){
    var subcat = subcat0.clone();
    subcat.append($('<a href="javascript:void(0);" class="remove"/></a>').on('click', removeSubCat));
    resetSubCat(subcat, 'subcat_'+('_abc'[i]));
    initDropDown(subcat, loadProfiles);
    subcats.append(subcat);
    return subcat;
}
function resetSubCat(subcat, newid){
    if (newid != undefined)
        $('div[id]', subcat).attr('id', newid);
    formNoError({}, $('.form_field', subcat));
    $('input', subcat).attr('required', 'required').val('');
    $('.current', subcat).text('wybierz podkategorię');
    $('.profiles', subcat).hide().children().remove();
}
function updateSubCats(catid, load){
    // if subcat is not required
    if (catid == 3 || catid == 5){
        $('input', subcat0).removeAttr('required');
        // hide subcats region
        subcats.hide();
        return;
    }

    if (load){
        var list = $('.dropdown_list', subcat0);
        // load subcat list for given catid
        $.ajax({
            url: '/webfront/notice/getsubcats',
            type: 'post',
            data: {cat: catid},
            dataType: 'json',
            success: function(res) {
                $(list).children().remove();
                for (var c in res.categories){
                    $(list).append($('<span itemid="'+c+'">'+res.categories[c]+'</span>'));
                }
                initDropDown(subcat0, loadProfiles);
            }
        });
    }

    // show subcats region if hidden
    subcats.show();
}
function removeSubCat(e) {
    e.preventDefault();
    var p = $(this).parent(), subcatid = $('input[type=text]', p).val();
    // remove subcat block
    p.remove();
    // show subcat on subcat list(s)
    dropDownHeight($('span[itemid='+subcatid+']').show().parent());
    // show add button
    addsubcat.show();
}
function loadProfiles(root, subcatid) {
    // hide selected subcat on subcat list(s)
    var subcat = $('span[itemid='+subcatid+']'), psubcatid = $('input[type=text]', root).val();
    if (psubcatid != undefined && psubcatid.length > 0)
        $('span[itemid='+psubcatid+']').show();
    var items = dropDownHeight(subcat.hide().parent());

    // get dropdown list element identifier sufix
    var id = $('[id]', root).attr('id').slice(-1);
    // get profiles list in current subcat
    var list = $('.profiles', root);
    // load profiles for subcatid
    $.ajax({
        url: '/webfront/notice/getprofiles',
        type: 'post',
        data: {cat: subcatid},
        dataType: 'json',
        success: function(res) {
            var p, n, e, c = data.profiles ? data.profiles[id] : [];
            $(list).hide().children().remove();
            for (p in res.profiles){
                n = res.profiles[p];
                e = makeCheckbox('profiles'+id+p, 'profiles[]', n, p+'|'+n, 'zaznacz przynajmniej jedną specjalizacje');
                $(list).append(e);
                // check default boxes
                if ($.inArray(n, c) >= 0)
                    $('.checkbox', e).click();
            }
            // show list if created
            if ($(list).children().length > 0){
                $(list).show();
                // remove required if some box is checked
                validateCheckboxGroup({}, 'profiles'+id);
            }
        }
    });

    // show button if we can add next subcat section
    if (subcats.children().length < 3 && items.length > 0)
        addsubcat.show();
}
function phoneClick(elem){
    var root = $(elem).parent();
    if ($(elem).hasClass('remove')){
        root.remove();
    }
    else {
        var i = $('[name="phone[]"]', root.parent()).length;
        if (i > 5){
            alert('Możesz dodać tylko 5 numerów!');
            return;
        }

        var p = root.clone();
        $('label', p).html('&nbsp;'); // to avoid collapsing
        formNoError({}, $('input', p).attr('id', 'phone'+(i+1)).val('').on('keydown', intField).on('paste', intField));
        $('a', p).addClass('remove').html('');
        $('.phone:last').after(p);
    }
}
function imgClick(e){
    formNoError(e, this);
    $(this).next().trigger('click');
}
function addPhoto(input){
    var input = input.length ? input[0] : input;
    if (input && input.value && input.value.length > 5) {
        var ctx = $(input).parent(), img = $(input).prev();
        // Files API check (IE <= 9)
        if (input.files && input.files[0]){ 
            if (input.files[0].size > 2097152){
                $('#photo_error').show();
                removePhoto(ctx);
                img.addClass('file_error');
                return;
            }
            var reader = new FileReader();
            reader.onload = function (e) {
                var image = new Image();
                image.onload = function() {
                    adjustPhoto(this, ctx);
                };
                image.src = e.target.result;
            };
            reader.readAsDataURL(input.files[0]);
        }
        else {
            $('a', ctx).show();
        }

        // remove errors if any
        $('#photo_error').hide();
        $('.file_error', ctx.parent()).removeClass('file_error');
    }
    return false;
}
function removePhoto(elem){
    var ctx = $(elem).closest('.photo'), img = $('img', ctx);
    if (ctx.hasClass('profile'))
        img.attr('src', '/images/profile_photo.png').removeClass('file_error');
    else
        img.attr('src', '/images/photo.png').removeClass('file_error');
    $('input', ctx).val('');
    $('a', ctx).hide();
}
function addReference(input){
    var input = input.length ? input[0] : input;
    if (input && input.value && input.value.length > 5) {
        var ctx = $(input).closest('.reference');
        if (input.files && input.files[0].size > 2097152){
            $('#reference_error').show();
            removeReference(ctx);
            $('img', ctx).addClass('file_error');
            return;
        }

        adjustReference(ctx);

        // hide errors if any
        $('#reference_error').hide();
        $('.file_error', ctx.parent()).removeClass('file_error');
    }
}
function adjustReference(ctx){
    $('img', ctx).attr('src', '/images/ref_b.jpg');
    $('input[type=text]', ctx).attr('required', 'required').show();
    $('a', ctx).show();
    return true;
}
function removeReference(elem){
    var ctx = $(elem).closest('.reference');
    $('img', ctx).attr('src', '/images/ref_a.png').removeClass('file_error');
    $('input', ctx).val('').removeAttr('required').hide();;
    $('a', ctx).hide();
}
function sectionClick(elem){
    var btn = $('p', elem);
    if (btn.hasClass('expand')){
        btn.switchClass('expand', 'fold').text('zwiń');
        $(elem).next().show();
    }
    else {
        btn.switchClass('fold', 'expand').text('rozwiń');
        $(elem).next().hide();
    }
}
function extraFields(catid){
    // hide extra sections for all categories except: 2 - korepetycje, 3 - pomoce, 5 - nianie
    if (!(catid == 2 || catid == 3 || catid == 5)){
        $('#extra').hide();
        $('.extra_field').remove();
        $('#area').parent().hide();
        $('#area_id').val(-1); // mark as hidden
        return;
    }

    // show extra section and hide errors
    $('#extra').show();
    formNoError({}, $('#extra h1'));

    // add fields in main section
    var field, main = $('#main_section');
    if (main.length > 0 && $('.extra_field', main).length < 1){
        // staż
        main.append(makeDropDown('staz', 'staż*', 'width: 150px', 'wybierz', 'podaj staż', {0: 'brak', 3: '1 do 3 lat', 5: '3 do 5 lat', 99: 'powyżej 5 lat'}, data.extra ? data.extra.staz : undefined));
        // płeć
        main.append(makeDropDown('plec', 'płeć*', 'width: 150px', 'wybierz', 'podaj płeć', {kobieta: 'kobieta', mezczyzna: 'mężczyzna'}, data.extra ? data.extra.plec : undefined));
        // wiek
        field = $('<div class="noticeform_row extra_field"></div>');
        field.append($('<label class="form_label">wiek*</label>'));
        field.append($('<input id="wiek" type="text" class="form_field" style="width: 150px" name="extra[wiek]" required="required" pattern="[0-9]{2}" maxlength="2" oninvalid="formError(event, this, \'podaj wiek\');" onchange="formError(event, this);" />').on('keydown', intField).on('paste', intField));
        if (data.extra) $('input', field).val(data.extra.wiek);
        main.append(field);
        // wynagrodzenie
        field = $('<div class="noticeform_row extra_field"></div>');
        field.append($('<label class="form_label">wynagrodzenie*</label>'));
        field.append($('<input id="wynagr" type="text" class="form_field" style="width: 150px" name="extra[wynagr]" required="required" pattern="[0-9]{1,3}((,|\.)([0-9]{1,2}))?" maxlength="6" oninvalid="formError(event, this, \'podaj wynagrodzenie\');" onchange="formError(event, this);" />').on('keydown', numField).on('paste', numField));
        field.append($('<label class="form_label">PLN/h</label>'));
        if (data.extra) $('input', field).val(data.extra.wynagr);
        main.append(field);
    }

    // remove all existing fields in extra section
    var hours = $('#hours'); // store subsection before clean up
    var extra = hours.parent();
    extra.children().remove();

    // fields in extra section
    if (catid == 2){ // korepetycje
        extra.append(makeCheckboxGroup('zakrszk_', 'zakres nauczania*', [
            ['zakrszk1', 'extra[zakr_szk_podst]', 'szkoła podstawowa', 1],
            ['zakrszk2', 'extra[zakr_szk_gimn]',  'gimnazjum', 1],
            ['zakrszk3', 'extra[zakr_szk_sred]',  'szkoła średnia', 1],
            ['zakrszk4', 'extra[zakr_szk_studia]',  'studia', 1],
        ], 'podaj zakres nauczania'));
        extra.append(makeCheckboxGroup('miejnaucz_', 'miejsce spotkań*', [
            ['miejnaucz1', 'extra[miejsce_naucz]', 'u nauczyciela', 1],
            ['miejnaucz2', 'extra[miejsce_ucz]', 'u ucznia', 1],
            ['miejnaucz3', 'extra[miejsce_skype]', 'skype', 1]
        ], 'podaj miejsce spotkań'));
        extra.append(makeCheckboxGroup('inne_', 'inne', [
            ['inne1', 'extra[pisrozw]', 'pisanie prac / rozwiązywanie zadań', 'tak'],
            ['inne2', 'extra[nauczdypl]', 'nauczyciel dyplomowany', 'tak']
        ]));
    }
    else if (catid == 3){ // pomoce domowe
        extra.append(makeCheckboxGroup('umiej_', 'umiejętności*', [
            ['umiej1', 'extra[mycieokien]', 'mycie okien', 'tak'],
            ['umiej2', 'extra[prawojazdy]', 'prawo jazdy', 'tak'],
            ['umiej3', 'extra[ogrod]', 'ogród', 'tak'],
            ['umiej4', 'extra[pali]', 'pali', 'tak'],
            ['umiej5', 'extra[prasowanie]', 'prasowanie', 'tak'],
            ['umiej6', 'extra[zakupy]', 'zakupy', 'tak'],
            ['umiej7', 'extra[pranie]', 'pranie', 'tak'],
            ['umiej8', 'extra[gotowanie]', 'gotowanie', 'tak'],
            ['umiej9', 'extra[sprzatanie]', 'sprzątanie biur', 'tak'],
        ], 'podaj umiejętności'));
    }
    else if (catid == 5){ // nianie i opiekunki
        extra.append(makeCheckboxGroup('opieka_', 'opieka*', [
            ['opieka1', 'extra[opieka_u_klienta]', 'u klienta', 1],
            ['opieka2', 'extra[opieka_u_niani]', 'u niani', 1],
        ], 'podaj miejsce pracy'));
        extra.append(makeCheckboxGroup('pracazdz_', 'praca z dziećmi*', [
            ['pracdz1', 'extra[pracazdz_1_12m]', '1-12 miesięcy', 1],
            ['pracdz2', 'extra[pracazdz_1_3]', '1 do 3 lat', 1],
            ['pracdz3', 'extra[pracazdz_3]', 'pow. 3 lat', 1],
        ], 'podaj grupę wiekową'));
        extra.append(makeCheckboxGroup('inne_', 'inne', [
            ['inne1', 'extra[niepeln]', 'dzieci niepełnosprawne', 'tak'],
            ['inne2', 'extra[prawojazdy]', 'prawo jazdy', 'tak'],
            ['inne3', 'extra[osobystarsze]', 'osoby starsze', 'tak'],
            ['inne4', 'extra[pali]', 'pali', 'tak'],
            ['inne5', 'extra[wyjsciamia]', 'wyjścia do miasta', 'tak'],
            ['inne6', 'extra[porzadki]', 'porządki', 'tak'],
            ['inne7', 'extra[pranie]', 'pranie', 'tak'],
            ['inne8', 'extra[gotowanie]', 'gotowanie', 'tak'],
            ['inne9', 'extra[opiekazw]', 'opieka nad zwierzętami', 'tak'],
        ]));
    }

    // add hours subsection
    extra.append(hours);

    // show area field
    $('#area').parent().show();
    if ($('#area_id').val() < 0){
        $('#area .current').text('wybierz obszar');
        $('#area_id').val('');
    }

    // set previous values
    if (data.extra){
        for(var key in data.extra){
            $('input[name="extra['+key+']"] + .checkbox').click();
        }
    }
}
function makeDropDown(id, label, style, defval, error_msg, items, curval){
    var field, list, row = $('<div class="noticeform_row extra_field"></div>');
    row.append($('<label class="form_label">'+label+'</label>'));
    row.append(field = $('<div id="'+id+'" class="form_field dropdown" style="'+style+'"></div>'));
    field.append($('<input type="text" style="display: none;" name="extra['+id+']" required="required" oninvalid="formError(event, $(this).parent(), \''+error_msg+'\');" onchange="formError(event, $(this).parent());" />'));
    field.append($('<div class="current">'+defval+'</div>'));
    field.append(list = $('<div class="dropdown_list" style="display: none;"></div>'));
    for (var id in items)
        list.append($('<span itemid="'+id+'">'+items[id]+'</span>'));

    initDropDown(row);
    if (curval != undefined)
        $('span[itemid="'+curval+'"]', list).click();

    return row;
}
function makeCheckbox(id, name, label, val, error_msg, anchor){
    var anchor = anchor || '$(this).parent().parent().parent()', group = id.match(/[a-z]*/)[0];
    var chk = error_msg ? 'required="required" oninvalid="formError(event, $(this).parent().parent().parent(), \''+error_msg+'\', '+anchor+');" onchange="validateCheckboxGroup(event, \''+group+'\');"' : '';
    var row = $('<div class="checkbox_wrap" />');
    row.append($('<input type="checkbox" id="'+id+'" name="'+name+'" value="'+val+'" style="display:none;" '+chk+'>'))
       .append($('<div class="checkbox" onclick="Action.CheckThisField(this);" />'))
       .append($('<span class="checkbox_label">'+label+'</span>'));
    return row;
}
function makeCheckboxGroup(id, label, checkboxes, error_msg){
    var list, row = $('<div id="'+id+'" class="noticeform_row checkbox_group extra_field" />');
    row.append($('<label class="form_label">'+label+'</label>'));
    row.append(list = $('<div style="float: left;" />'));
    for(var c in checkboxes){
        if (error_msg) checkboxes[c].push(error_msg);
        list.append(makeCheckbox.apply(this, checkboxes[c]));
    }
    return row;
}
function addComment(data){
    var container = $('#noticeform_comments');
    if (container.length < 1) return;
    var comment = $('<div class="noticeform_row"></div>');
    if (data == undefined) {
        var data = {
            id: 0,
            name: $('#name').val(),
            date: $('#date').val(),
            comment: $('#content').val(),
        };
        if (data.name.length < 2 || data.date.length < 10 || data.comment.length < 2)
            return;

        // copy stars
        $('[name*="vote_sco"]').each(function(i,e){
            var name = $(e).attr('name').replace('vote_', '');
            data[name.replace('sco_', '')] = $(e).val();
            SiteContainer.deselectVote($(e).val(0), name);
        });

        $('#name').val('');
        $('#date').val((new Date()).toISOString().slice(0,10));
        $('#content').val('');
    }

    var ranks = $('<div class="voting" style="margin-top: 5px;"></div>');
    var cat = $('#maincat_id').val();
    var tmp = stars[cat] || stars[0];
    for (var i in tmp) {
        var item = tmp[i];
        addRank(ranks, reviews[item], 'sco_'+item, data[item]);
    }

    comment.append($('<input type="hidden" name="comment_id[]" value="'+data.id+'" />'));
    comment.append($('<input type="hidden" name="comment_name[]" value="'+data.name+'" />'));
    comment.append($('<input type="hidden" name="comment_date[]" value="'+data.date+'" />'));
    comment.append($('<label class="form_label" style="line-height: normal;">'+data.name+'<br />('+data.date+')</label>'));
    comment.append($('<input type="hidden" name="comment[]" value="'+data.comment+'" />'));
    var content = $('<div class="form_label" style="width: calc(100% - 185px); line-height: normal;">'+data.comment+'</div>');
    content.append(ranks);
    comment.append(content);

    comment.append($('<a href="javascript:void(0);" class="edit"></a>').on('click', editComment));
    comment.append($('<a href="javascript:void(0);" class="remove"></a>').on('click', removeComment));

    container.append(comment);
}
function addRank(ranks, label, name, val){
    var val = val || 0;
    var div = $('<div class="clearfix" style="float: left;"></div>');
    div.append('<input type="hidden" name="'+name+'[]" value="'+val+'" />​');
    div.append('<span style="margin: 0 8px;">'+label+'</span>');
    for (i = 0; i < 5; ++i){
        if (i < val)
            div.append('<i class="fa fa-star colored"></i>');
        else
            div.append('<i class="fa fa-star"></i>');
    }
    ranks.append(div);
    return div;
}
function editComment(e){
    var comment = $(this).parent();

    $('[name*="vote_sco"]').each(function(i,e){
        var name = $(e).attr('name').replace('vote_', '');
        var val = $('[name="'+name+'[]"]', comment).val();
        SiteContainer.deselectVote($(e).val(val), name);
    });

    $('#name').val($("[name='comment_name[]']", comment).val());
    $('#date').val($("[name='comment_date[]']", comment).val());
    $('#content').val($("[name='comment[]']", comment).val());

    removeComment(e, comment);
    $('#content').focus();
}
function removeComment(e, comment){
    var comment = comment || $(this).parent();
    var id = $('[name="comment_id[]"]', comment);
    if (id.length > 0 && id.val() > 0){
        id.val(-id.val());
        comment.hide();
    }
    else
        comment.remove();
}
function validateDate(event, form){
    var t = new Date(new Date().getTime() + 24 * 60 * 60 * 1000);
    var i = $('#date', form);
    var d = new Date(i.val());
    if (d > t)
        formError(event, i, 'nieprawidlowa data');
    else
        formNoError(event, i);        
}
function validateCheckboxGroup(event, group, msg){
    var chxg = $("input:checkbox[id^='"+group+"']");
    $(chxg).attr('required', 'required');
    if ($(chxg).is(':checked')){
        $(chxg).removeAttr('required');
        formNoError(event, chxg.first().closest('.noticeform_row'));
    }
}
function validateNoticeForm(form, event){
    if (valid) {
        return true;
    } else {
        // send required data to server side validation
        var data = {};
        $('[required=required],[type=checkbox]', form).each(function(i,e){
            if (e == null || e.name == null)
                return;
            if (e.name.match(/\[\]/)){
                if (!data[e.name] || !data[e.name].length)
                    data[e.name] = [$(e).val()];
                else
                    data[e.name].push($(e).val());
            }
            else if (e.type != 'checkbox' || e.checked)
                data[e.name] = $(e).val();
        });
        formNoError(event);
        $.ajax({
            url: '/webfront/notice/validate',
            type: 'post',
            dataType: 'json',
            data: data,
            /*
            data: {
                id: $('#id').val(),
                title: $('#title').val(),
                maincat_id: $('#maincat_id').val(),
                subcat_id: $("[name='subcat_id[]'").map(function(i,e){return $(e).val()}).toArray(),
                city: $('#city').val(),
                postcode1: $('#postcode1').val(),
                postcode2: $('#postcode2').val(),
                area_id: $('#area_id').val(),
                phone: $("[name='phone[]'").map(function(i,e){return $(e).val()}).toArray(),
            },
            */
            success: function(res) {
                if (res == undefined || res.success == undefined){
                    formError({}, $(undefined), 'error');
                }
                else if (res.success == true) {
                   valid = true;
                   $('#noticeform').submit();
                } 
                else {
                    for (var id in res.errors) {
                        var elem = $('#'+id), anchor = id.match(/_$/) ? elem : null;
                        formError(event, elem, res.errors[id], anchor);
                    }
                }
            }
        });
    }

    return false;
}
