function initWorkersDropDown(dt, col){
    var column = dt.api().columns(col);
    var select = $('<select><option value=""></option></select>')
        .appendTo($(column.header()))
        .on('change', function(){
            var val = $(this).val();
            if (!column.context[0].json)
                val = '^'+$.fn.dataTable.util.escapeRegex(val)+'$';

            column.search(val ? val : '', true, false).draw();
        });

    $.ajax({
        dataType: "json",
        url: '/webfront/panel/workerslist',
        success: function(data){
            $.each(data, function(id,text){
                select.append('<option value="'+(column.context[0].json?id:text)+'">'+text+'</option>');
            });
        }
    })
}

function lpColumn(data, type, full, meta) {
    var total = meta.settings._iRecordsTotal > 0 ? meta.settings._iRecordsTotal : meta.settings.nTBody.children.length;
    return total - meta.settings._iDisplayStart - meta.row;
}

var enum_status = ['nie potwierdzony', 'potwierdzony', null, null, null, null, null, null, null, 'normalny'];
function statusColumn(data, type, full, meta) {
    var v = enum_status[data];
    return v || ('nieznany '+data);
}

var enum_type = ['inny', 'użytkownik', 'email', 'fb', null, 'pracownik'];
function typeColumn(data, type, full, meta) {
    var v = enum_type[data];
    return v || ('nieznany '+data);
}

function areyousure(item){
    return confirm('Czy na pewno chcesz usunąć "'+item+'"?');
}
